// $Id: jsnippets.js,v 1.4 2009/03/02 19:58:08 karthik Exp $

Drupal.behaviors.jsnippets_onload = function() {
  if (typeof jsnippets_get_all != 'undefined') {
    var s = jsnippets_get_all();
    jsnippets_add_selects(s);
  }
}

function jsnippets_add_selects(jsnippets) {
  for (var id in jsnippets) {
    var textarea = $('#' + id).get(0);
    var select = jsnippets_add_select(textarea, jsnippets[id], 'jsnippet-' + id);
    select.change(
      function() {
        if (this.value != 'none') {
          select.addClass('throbbing');
          $.getJSON(Drupal.settings.basePath + "jsnippets/retrieve/" + this.value, null, function(json) {
            if (textarea.value.length > 0) {
              textarea.value += '\n\n' + json[select.get(0).value];
            }
            else {
              textarea.value = json[select.get(0).value];
            }
            textarea.scrollTop = textarea.scrollHeight - textarea.clientHeight;
            select.removeClass('throbbing');
          });
        }
      }
    );
  }
}

function jsnippets_add_select(textarea, jsnippet, jsnippet_id) {
  var div = document.createElement('div');
  div.className = 'jsnippet';
  div.id = jsnippet_id;
  var select = div.appendChild(document.createElement('select'));
  for (var o in jsnippet) {
    var opt = select.appendChild(document.createElement('option'));
    opt.value = o;
    opt.innerHTML = jsnippet[o];
  }
  document.body.appendChild(div);
  select = $('#' + jsnippet_id);
  select_element = select.get(0);
  select.addClass('autocomplete');

  p = $(textarea).offset();
  select.css('right', (p.left + textarea.clientWidth - select_element.clientWidth) + 'px');
  select.css('top', (p.top - select_element.clientHeight) + 'px');
  select = $('#' + jsnippet_id + ' select');

  return select;
}
